unit ChildWinAGif;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CHILDWIN, ImageEn, ExtCtrls, StdCtrls, ComCtrls, ImageEnProc, ImageEnView, ImageEnIO,
  RulerBox, iedefs;

type
  TMDIChildAG = class(TMDIChild)
    Panel1: TPanel;
    Label1: TLabel;
    ScrollBar1: TScrollBar;
    Label2: TLabel;
    Label3: TLabel;
    Edit2: TEdit;
    UpDown2: TUpDown;
    Label4: TLabel;
    Edit3: TEdit;
    Label5: TLabel;
    Edit4: TEdit;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Panel2: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    ScrollBox1: TScrollBox;
    Panel3: TPanel;
    procedure ScrollBar1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ImageEn1ImageChange(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Panel3Click(Sender: TObject);
  private
    { Private declarations }
    DontChange:boolean;
    procedure ImClick(Sender:TObject);
    procedure EditTOGifInfo;
    procedure GifInfoTOEdit;
  public
    { Public declarations }
    procedure Load;
    procedure Save;
  end;

var
  MDIChildAG: TMDIChildAG;

implementation

uses ColorSel, Main, GifLZW, IEUtils;

{$R *.DFM}

////////////////////////////////////////////////////////////////////////////////////
procedure TMDIChildAG.GifInfoTOEdit;
begin
  if ScrollBox1.ControlCount>0 then begin
	  DontChange:=true;
     Label2.caption:=inttostr(ScrollBar1.Position);
     with (ScrollBox1.Controls[ScrollBar1.Position] as TImageEn).IOParams do begin
		  edit2.text:=inttostr( GIF_DelayTime );
		  edit3.text:=inttostr( GIF_XPos );
		  edit4.text:=inttostr( GIF_YPos );
		  checkbox1.checked:= GIF_Interlaced;
		  checkbox2.checked:= GIF_FlagTranspColor;
        Panel3.color:=TRGB2TColor( GIF_TranspColor );
     end;
	  DontChange:=false;
  end;
end;

////////////////////////////////////////////////////////////////////////////////////
procedure TMDIChildAG.EditTOGifInfo;
begin
	if ScrollBox1.ControlCount>0 then
   	with (ScrollBox1.Controls[ScrollBar1.Position] as TImageEn).IOParams do begin
		   GIF_DelayTime:=strtointdef(edit2.text,0);
		   GIF_XPos:=strtointdef(edit3.text,0);
		   GIF_YPos:=strtointdef(edit4.text,0);
		   GIF_Interlaced:=checkbox1.checked;
		   GIF_FlagTranspColor:=checkbox2.checked;
         GIF_TranspColor:=TColor2TRGB(Panel3.Color);
      end;
end;

////////////////////////////////////////////////////////////////////////////////////
// Image list -> imageen1
procedure TMDIChildAG.ScrollBar1Change(Sender: TObject);
begin
  inherited;
  GifInfoTOEdit;
  DontChange:=true;
  ImageEnView1.assign( ScrollBox1.Controls[ScrollBar1.Position] as TImageEn );
  DontChange:=false;
  MainForm.ComboBox1Change(self);	// Adjust zoom
end;

////////////////////////////////////////////////////////////////////////////////////
procedure TMDIChildAG.Load;
var
	q,numim,t,w:integer;
begin
  // free pred images
  for q:=0 to ScrollBox1.ControlCount-1 do
  		ScrollBox1.controls[q].free;
  // images in scrollbox1
  numim:=EnumGifIm(Caption);
  scrollbox1.vertscrollbar.range:=scrollbox1.height-3;
  t:=0;
  w:=ScrollBox1.ClientWidth;
  for q:=0 to numim-1 do begin
  		with TImageEn.Create(ScrollBox1) do begin
         LockPaint;
      	Left:=0;
         Top:=t;
			Width:=w;
         Height:=w;
         OnClick:=ImClick;
      	Parent:=ScrollBox1;
         IOParams.GIF_ImageIndex:=q;
			IOParams.GIF_LZWDECOMPFUNC:=GIFLZWDecompress;
		   IOParams.GIF_LZWCOMPFUNC:=GIFLZWCompress;
         LoadFromFileGif(self.caption);
         Fit;
         Height:=IdealComponentHeight;
         inc(t,Height+1);
         UnLockPaint;
      end;
  end;
  if t>scrollbox1.vertscrollbar.range then
	  scrollbox1.vertscrollbar.range:=t;
  ScrollBar1.max:=numim-1;
end;

////////////////////////////////////////////////////////////////////////////////////
// click on a frame
procedure TMDIChildAG.ImClick(Sender:TObject);
begin
	scrollbar1.Position:=(Sender as TImageEn).IOParams.GIF_ImageIndex;
end;

////////////////////////////////////////////////////////////////////////////////////
procedure TMDIChildAG.FormCreate(Sender: TObject);
begin
  inherited;
  DontChange:=false;
end;

////////////////////////////////////////////////////////////////////////////////////
procedure TMDIChildAG.Save;
var
   q:integer;
begin
	for q:=0 to scrollbox1.ControlCount-1 do
   	with scrollbox1.Controls[q] as TImageEn do
	      if q=0 then
	        	SaveToFileGif(Caption)
			else
	        	InsertToGif(Caption);
	Changed:=false;
end;

////////////////////////////////////////////////////////////////////////////////////
// Copy ImageEn1 -->> Active image
procedure TMDIChildAG.ImageEn1ImageChange(Sender: TObject);
begin
  inherited;
  if not DontChange then begin
  	  with ScrollBox1.Controls[ScrollBar1.Position] as TImageEn do begin
     	  LockPaint;
		  Assign(ImageEnView1);
	     Fit;
        UnLockPaint;
     end;
     GifInfoTOEdit;
  end;
end;

////////////////////////////////////////////////////////////////////////////////////
// Change controls
procedure TMDIChildAG.Edit2Change(Sender: TObject);
begin
  inherited;
  if not DontChange then
	  EditTOGifInfo;
end;

////////////////////////////////////////////////////////////////////////////////////
// Delete frame
procedure TMDIChildAG.Button2Click(Sender: TObject);
var
	t,q:integer;
   numim:integer;
   todel:integer;	// index of frame to delete
   lp:integer;
begin
  inherited;
  if scrollbox1.ControlCount>1 then begin
	  todel:=scrollbar1.Position;
     lp:=scrollbox1.VertScrollBar.Position;
     scrollbox1.VertScrollBar.Position:=0;
	  t:=(scrollbox1.Controls[todel] as TImageEn).Top;
	  scrollbox1.Controls[todel].free;
	  numim:=scrollbox1.ControlCount;
	  scrollbox1.vertscrollbar.range:=scrollbox1.height-3;
	  scrollbar1.max:=numim-1;
     // move up
	  for q:=todel to scrollbox1.ControlCount-1 do
	  		with ScrollBox1.Controls[q] as TImageEn do begin
	         Top:=t;
            IOParams.GIF_ImageIndex:=q;
	         inc(t,Height+1);
	      end;
	  if t>scrollbox1.vertscrollbar.range then
		  scrollbox1.vertscrollbar.range:=t;
     scrollbox1.VertScrollBar.Position:=lp;
  end else
     ImageEnProc1.clear;
  ScrollBar1Change(self);
end;

////////////////////////////////////////////////////////////////////////////////////
// Insert blank frame
procedure TMDIChildAG.Button1Click(Sender: TObject);
var
 	t,w,q,lp:integer;
   numim,toadd:integer;
	ls:TList;
begin
  inherited;
  toadd:=ScrollBar1.Position;
  numim:=scrollbox1.ControlCount;
  lp:=scrollbox1.VertScrollBar.Position;
  scrollbox1.VertScrollBar.Position:=0;
  //
  t:=(scrollbox1.Controls[toadd] as TImageEn).Top;
  // get list of created controls
  ls:=TList.Create;
  for q:=toadd to numim-1 do begin
  		ls.add(ScrollBox1.Controls[toadd]);  // add to ls
      ScrollBox1.RemoveControl(ScrollBox1.Controls[toadd]);	// remove from ScrollBox1
  end;
  // Add new blank image to ScrollBox1
  inc(numim);
  scrollbox1.vertscrollbar.range:=scrollbox1.height-3;
  scrollbar1.max:=numim-1;
  w:=ScrollBox1.ClientWidth;
  with TImageEn.Create(ScrollBox1) do begin
  		LockPaint;
     	Left:=0;
      Top:=t;
   	Width:=w;
      Height:=w;
      OnClick:=ImClick;
     	Parent:=ScrollBox1;
      dontchange:=true;
      AssignIOParams(TImageEn(ls[toadd]));
      IOParams.GIF_ImageIndex:=toadd;
      resize(IOParams.Width,IOParams.Height);
      background:=TRGB2TCOLOR(IOParams.GIF_Background);
      dontchange:=false;
      clear;
      Fit;
      Height:=IdealComponentHeight;
      UnLockPaint;
      inc(t,Height+1);
  end;
  // Add other images
  for q:=0 to ls.count-1 do begin
  		scrollbox1.InsertControl( TControl(ls[q]) );
      with (scrollbox1.controls[toadd+q+1] as TImageEn) do begin
      	Top:=t;
         IOParams.GIF_ImageIndex:=toadd+q+1;
			Parent:=ScrollBox1;
      	inc(t,Height+1);
      end;
  end;
  if t>scrollbox1.vertscrollbar.range then
	  scrollbox1.vertscrollbar.range:=t;
  scrollbox1.VertScrollBar.Position:=lp;
  ScrollBar1.max:=numim-1;
  ScrollBar1Change(self);
  //
  ls.free;
end;

////////////////////////////////////////////////////////////////////////////////////
// Append blank frame
procedure TMDIChildAG.Button3Click(Sender: TObject);
var
	t,w,lp:integer;
   numim:integer;
begin
  inherited;
  numim:=scrollbox1.ControlCount;
  lp:=scrollbox1.VertScrollBar.Position;
  scrollbox1.VertScrollBar.Position:=0;
  scrollbox1.vertscrollbar.range:=scrollbox1.height-3;
  //
  if numim>0 then
	  with scrollbox1.Controls[numim-1] as TImageEn do
		  t:=Top+Height+1
  else
     t:=0;
  //
  w:=ScrollBox1.ClientWidth;
  with TImageEn.Create(ScrollBox1) do begin
		LockPaint;
     	Left:=0;
      Top:=t;
   	Width:=w;
      Height:=w;
      OnClick:=ImClick;
    	Parent:=ScrollBox1;
      dontchange:=true;
      if numim>0 then
      	AssignIOParams(ScrollBox1.Controls[numim-1] as TImageEn)
      else begin
			IOParams.GIF_LZWDECOMPFUNC:=GIFLZWDecompress;
		   IOParams.GIF_LZWCOMPFUNC:=GIFLZWCompress;
		end;
      IOParams.GIF_ImageIndex:=numim;
      resize(IOParams.Width,IOParams.Height);
      background:=TRGB2TCOLOR(IOParams.GIF_Background);
      dontchange:=false;
      clear;
      Fit;
      Height:=IdealComponentHeight;
      UnLockPaint;
      inc(t,Height+1);
  end;
  if t>scrollbox1.vertscrollbar.range then
	  scrollbox1.vertscrollbar.range:=t;
  scrollbox1.VertScrollBar.Position:=lp;
  ScrollBar1.max:=numim;
  ScrollBar1.position:=numim;
  ScrollBar1Change(self);
end;

////////////////////////////////////////////////////////////////////////////////////
// Activate
procedure TMDIChildAG.FormActivate(Sender: TObject);
begin
  inherited;
  if scrollbox1.ControlCount=0 then
  		// create new blank image
      Button3Click(self);	// append blank
end;

////////////////////////////////////////////////////////////////////////////////////
// Select Transparent color
procedure TMDIChildAG.Panel3Click(Sender: TObject);
var
	PalDial:TImageEnPaletteDialog;
   Palette:array [0..255] of TRGB;
begin
  inherited;
  ImageEnProc1.CalcImagePalette(Palette,256);
  PalDial:=TImageEnPaletteDialog.Create(self);
  PalDial.SetPalette(Palette,256);
  if PalDial.Execute then
  		Panel3.Color:=PalDial.SelCol;
  if not DontChange then
	  EditTOGifInfo;
  PalDial.free;
end;

end.
